package com.apm;


import com.alibaba.fastjson.JSON;
import com.aliyuncs.DefaultAcsClient;
import com.aliyuncs.auth.sts.AssumeRoleRequest;
import com.aliyuncs.auth.sts.AssumeRoleResponse;
import com.aliyuncs.http.MethodType;
import com.aliyuncs.profile.DefaultProfile;
import com.aliyuncs.profile.IClientProfile;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;

import java.net.URLEncoder;
import java.util.HashMap;

import static java.lang.System.exit;



@Controller
public class MyController {

    // 子账号的ak(需要替换成各自的子账号ak）
    String akId = "your ak";
    // 子账号的sk(需要替换成各自的子账号secret）
    String secret = "your secret";
    // 角色的Arn值(需要替换成各自角色Arm值）
    String roleArn = "acs:ram::1564443061300567:role/xtracepage"; // 替换role
    String roleSession = "console-role-session";
    String stsHost = "sts.aliyuncs.com";
    String signInHost = "http://signin.aliyun.com";
    private CloseableHttpClient httpClient = HttpClients.createDefault();

    String tokenUrl = "";
    @RequestMapping("/")
    public String helloHtml(HashMap<String,Object> map) throws Exception {
        if (tokenUrl == null || tokenUrl.length() ==0) {
            tokenUrl = getTokenUrl();
        }
        map.put("url",accessSign(tokenUrl));
        return"embedPage";
    }

    private String getTokenUrl() throws Exception {

        DefaultProfile.addEndpoint("", "", "Sts", stsHost);
        IClientProfile profile = DefaultProfile.getProfile("", akId, secret);
        DefaultAcsClient client = new DefaultAcsClient(profile);

        AssumeRoleRequest assumeRoleReq = new AssumeRoleRequest();
        assumeRoleReq.setRoleArn(roleArn);
        assumeRoleReq.setRoleSessionName(roleSession);
        assumeRoleReq.setMethod(MethodType.POST);
        assumeRoleReq.setDurationSeconds(3600L);
        // 默认可以不需要setPolicy，即申请获得角色的所有权限
        //assumeRoleReq.setPolicy(本次生成token实际需要的权限字符串，申请权限必须是角色对应权限的子集); // 权限示例参考链接：https://help.aliyun.com/document_detail/89676.html

        AssumeRoleResponse assumeRoleRes = client.getAcsResponse(assumeRoleReq);
        System.out.println(assumeRoleRes.getCredentials().getAccessKeyId());
        System.out.println(assumeRoleRes.getCredentials().getAccessKeySecret());
        System.out.println(assumeRoleRes.getCredentials().getExpiration());
        System.out.println(assumeRoleRes.getCredentials().getSecurityToken());

        // construct sign in url
        String signInTokenUrl = signInHost + String.format(
                "/federation?Action=GetSigninToken"
                        + "&AccessKeyId=%s"
                        + "&AccessKeySecret=%s"
                        + "&SecurityToken=%s&TicketType=mini",
                URLEncoder.encode(assumeRoleRes.getCredentials().getAccessKeyId(), "utf-8"),
                URLEncoder.encode(assumeRoleRes.getCredentials().getAccessKeySecret(), "utf-8"),
                URLEncoder.encode(assumeRoleRes.getCredentials().getSecurityToken(), "utf-8")
        );
        return signInTokenUrl;
    }

    private String accessSign(String signInTokenUrl) throws Exception {
        HttpGet signInGet = new HttpGet(signInTokenUrl);
        HttpResponse httpResponse = httpClient.execute(signInGet);
        String signInToken = "";
        if (httpResponse.getStatusLine().getStatusCode() == 200) {
            String signInRes = EntityUtils.toString(httpResponse.getEntity());
            System.out.println(signInRes);
            signInToken = JSON.parseObject(signInRes).getString("SigninToken");

            if (signInToken == null) {
                System.out.println("Invalid response message, contains no SigninToken: " + signInRes);
                exit(-1);
            }
        } else {
            System.out.println("Failed to retrieve signInToken");
            exit(-1);
        }

        System.out.println(signInToken);
        // construct final url
        String signInUrl = signInHost + String.format(
                "/federation?Action=Login"
                        + "&LoginUrl=%s"
                        + "&Destination=%s"
                        + "&SigninToken=%s",
                URLEncoder.encode("https://www.aliyun.com", "utf-8"),
                URLEncoder.encode("https://tracing-analysis.console.aliyun.com/?hideTopbar=true#/appList/cn-beijing", "utf-8"),
                URLEncoder.encode(signInToken, "utf-8"));
        return signInUrl;
    }
}
